export const makeRe = (keys) => {
  const k = `(${keys.join('|')})`
  const s = '(?:\\s+(?!\\/>)[^>]*?)?' // before closing >
  const re = new RegExp(`(\\r?\\n)?( *)(<${k}${s}(?:\\s*?/>|>[\\s\\S]*?<\\/\\4>))`, 'gm')
  return re
}
export const indent = (s, pad) => {
  return s.replace(/(^|(?:\r?\n))/g, `$1${pad}`)
}